#include "bbvtkImageCastToUShort.h"
#include "bbvtkPackage.h"
namespace bbvtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(vtk,ImageCastToUShort)
BBTK_BLACK_BOX_IMPLEMENTATION(ImageCastToUShort,bbtk::AtomicBlackBox);
void ImageCastToUShort::Process()
{
 
// THE MAIN PROCESSING METHOD BODY 
//   Here we simply set the input 'In' value to the output 'Out' 
//   And print out the output value 
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM : 
//    void bbSet{Input|Output}NAME(const TYPE&) 
//    const TYPE& bbGet{Input|Output}NAME() const  
//    Where : 
//    * NAME is the name of the input/output 
//      (the one provided in the attribute 'name' of the tag 'input') 
//    * TYPE is the C++ type of the input/output 
//      (the one provided in the attribute 'type' of the tag 'input') 

	vtkImageData* img = bbGetInputIn();	
	cast->SetInput(img);
	cast->SetOutputScalarTypeToUnsignedShort();
	cast->Update();
    bbSetOutputOut(cast->GetOutput() );   
  
}
void ImageCastToUShort::bbUserSetDefaultValues()
{
 
//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX  
//    Here we initialize the input 'In' to 0 
	cast = NULL;
   bbSetInputIn(0); 
  
}
void ImageCastToUShort::bbUserInitializeProcessing()
{
 
//  THE INITIALIZATION METHOD BODY : 
//    Here does nothing  
//    but this is where you should allocate the internal/output pointers  
//    if any  

	cast = vtkImageCast::New(); 
  
}
void ImageCastToUShort::bbUserFinalizeProcessing()
{
 
//  THE FINALIZATION METHOD BODY : 
//    Here does nothing  
//    but this is where you should desallocate the internal/output pointers  
//    if any 
  
}
}
// EO namespace bbvtk


